<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xi="http://www.w3.org/2001/XInclude"
                xmlns:xifunc="xalan://fr.in2p3.lavoisier.helpers.xinclude.XIncludeFunction"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:lav="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/config.xsd"
                exclude-result-prefixes="xi xifunc xalan lav">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>
    <xsl:strip-space elements="lav:*"/>
    <xsl:param name="version"/>

    <xsl:template match="/lav:config">
        <xsl:if test="@version != $version">
            <xsl:message terminate="yes">Your configuration files are incompatible with current version of Lavoisier.
Please run command lavoisier-update-config.</xsl:message>
        </xsl:if>
        <xsl:copy><xsl:copy-of select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="lav:view | lav:view-template">
        <xsl:copy><xsl:copy-of select="@*"/>
            <xsl:for-each select="(ancestor::*|descendant-or-self::*)/namespace::*
                                        [name()!='']
                                        [.!='http://www.w3.org/XML/1998/namespace']
                                        [.!='http://www.w3.org/2001/XInclude']">
                <namespace prefix="{name()}" uri="{.}"/>
            </xsl:for-each>
            <xsl:apply-templates select="* | text() | comment()"/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="xi:include[not(@xpointer)]">
        <xsl:apply-templates select="xifunc:xinclude(@href)"/>
    </xsl:template>
    <xsl:template match="xi:include[@xpointer]">
        <xsl:apply-templates select="xifunc:xinclude(@href, @xpointer)"/>
    </xsl:template>

    <!-- default rules -->
    <xsl:template match="comment()">
        <xsl:comment><xsl:value-of select="."/></xsl:comment>
    </xsl:template>
    <xsl:template match="*">
        <xsl:copy><xsl:copy-of select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>