<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:lav="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/config.xsd"
                exclude-result-prefixes="xalan lav">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>
    <xsl:strip-space elements="lav:*"/>

    <xsl:template match="lav:view[lav:processors/lav:for]">
        <xsl:for-each select="lav:processors/lav:for">
            <view name="{ancestor::lav:view/@name}_{count(preceding-sibling::lav:for)}" post-processors="disable-default-processors">
                <xsl:copy-of select="ancestor::lav:view/@*[not(local-name()='name' or local-name()='post-processors')]"/>
                <xsl:copy-of select="ancestor::lav:view/lav:namespace"/>
                <info>
                    <category>Hidden</category>
                </info>
                <authorized>
                    <entry>127.0.0.1</entry>
                </authorized>
                <xsl:apply-templates select="*"/>
            </view>
        </xsl:for-each>
        <xsl:copy><xsl:copy-of select="@*"/>
            <xsl:apply-templates select="* | text() | comment()"/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="lav:view/lav:processors/lav:for">
        <processor type="InsertXmlProcessor">
            <parameter name="namespaces">
                <xsl:for-each select="ancestor::lav:view/lav:namespace">
                    <entry key="{@prefix}"><xsl:value-of select="@uri"/></entry>
                </xsl:for-each>
            </parameter>
            <parameter name="nodes">
                <xsl:value-of select="@nodes"/>
            </parameter>
            <parameter name="xml" eval="view('{ancestor::lav:view/@name}_{count(preceding-sibling::lav:for)}', path(''))"/>
        </processor>
    </xsl:template>

    <!-- default rules -->
    <xsl:template match="@*">
        <xsl:copy-of select="."/>
    </xsl:template>
    <xsl:template match="*">
        <xsl:copy>
            <xsl:apply-templates select="@*|*|text()|comment()"/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>