#!/bin/sh
# ----------------------------------------------------------------------------
#  Copyright 2001-2006 The Apache Software Foundation.
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
# ----------------------------------------------------------------------------
#
#   Copyright (c) 2001-2006 The Apache Software Foundation.  All rights
#   reserved.


# resolve links - $0 may be a softlink
PRG="$0"

while [ -h "$PRG" ]; do
  ls=`ls -ld "$PRG"`
  link=`expr "$ls" : '.*-> \(.*\)$'`
  if expr "$link" : '/.*' > /dev/null; then
    PRG="$link"
  else
    PRG=`dirname "$PRG"`/"$link"
  fi
done

PRGDIR=`dirname "$PRG"`
BASEDIR=`cd "$PRGDIR/.." >/dev/null; pwd`



# OS specific support.  $var _must_ be set to either true or false.
cygwin=false;
darwin=false;
case "`uname`" in
  CYGWIN*) cygwin=true ;;
  Darwin*) darwin=true
           if [ -z "$JAVA_VERSION" ] ; then
             JAVA_VERSION="CurrentJDK"
           else
             echo "Using Java version: $JAVA_VERSION"
           fi
           if [ -z "$JAVA_HOME" ] ; then
             JAVA_HOME=/System/Library/Frameworks/JavaVM.framework/Versions/${JAVA_VERSION}/Home
           fi
           ;;
esac

if [ -z "$JAVA_HOME" ] ; then
  if [ -r /etc/gentoo-release ] ; then
    JAVA_HOME=`java-config --jre-home`
  fi
fi

# For Cygwin, ensure paths are in UNIX format before anything is touched
if $cygwin ; then
  [ -n "$JAVA_HOME" ] && JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
  [ -n "$CLASSPATH" ] && CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
fi

# If a specific java binary isn't specified search for the standard 'java' binary
if [ -z "$JAVACMD" ] ; then
  if [ -n "$JAVA_HOME"  ] ; then
    if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
      # IBM's JDK on AIX uses strange locations for the executables
      JAVACMD="$JAVA_HOME/jre/sh/java"
    else
      JAVACMD="$JAVA_HOME/bin/java"
    fi
  else
    JAVACMD=`which java`
  fi
fi

if [ ! -x "$JAVACMD" ] ; then
  echo "Error: JAVA_HOME is not defined correctly." 1>&2
  echo "  We cannot execute $JAVACMD" 1>&2
  exit 1
fi

if [ -z "$REPO" ]
then
  REPO="$BASEDIR"/lib
fi

CLASSPATH=$CLASSPATH_PREFIX:"$BASEDIR"/etc:"$REPO"/lavoisier-service-1.9.jar:"$REPO"/lavoisier-engine-1.9.jar:"$REPO"/lavoisier-configuration-1.9.jar:"$REPO"/lavoisier-interfaces-1.9.jar:"$REPO"/xpath-parser-1.9.jar:"$REPO"/jaxen-1.1.4.jar:"$REPO"/dom4j-1.6.1.jar:"$REPO"/xml-apis-1.0.b2.jar:"$REPO"/lavoisier-chaining-1.9.jar:"$REPO"/straxpath-1.9.jar:"$REPO"/log4j-1.2.12.jar:"$REPO"/grizzly-http-server-2.2.21.jar:"$REPO"/grizzly-http-2.2.21.jar:"$REPO"/grizzly-framework-2.2.21.jar:"$REPO"/grizzly-rcm-2.2.21.jar:"$REPO"/lavoisier-cache-base-1.9.jar:"$REPO"/lavoisier-connector-base-1.9.jar:"$REPO"/lavoisier-connector-diff-1.9.jar:"$REPO"/xmlunit-1.3.jar:"$REPO"/lavoisier-connector-sql-1.9.jar:"$REPO"/mysql-connector-java-5.1.25.jar:"$REPO"/postgresql-9.2-1003-jdbc4.jar:"$REPO"/hsqldb-2.2.9.jar:"$REPO"/lavoisier-connector-ssh-1.9.jar:"$REPO"/jsch-0.1.49.jar:"$REPO"/lavoisier-processor-base-1.9.jar:"$REPO"/lavoisier-processor-xpath-1.9.jar:"$REPO"/lavoisier-renderer-base-1.9.jar:"$REPO"/lavoisier-renderer-pdf-1.9.jar:"$REPO"/itextpdf-5.1.3.jar:"$REPO"/xmlworker-1.1.1.jar:"$REPO"/lavoisier-serializer-base-1.9.jar:"$REPO"/lavoisier-serializer-html-1.9.jar:"$REPO"/jtidy-r938.jar:"$REPO"/lavoisier-serializer-json-1.9.jar:"$REPO"/jettison-1.0.1.jar:"$REPO"/stax-api-1.0.1.jar:"$REPO"/lavoisier-trigger-base-1.9.jar:"$REPO"/wrapper-3.2.3.jar:"$REPO"/lavoisier-package-1.9.jar

# For Cygwin, switch paths to Windows format before running java
if $cygwin; then
  [ -n "$CLASSPATH" ] && CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
  [ -n "$JAVA_HOME" ] && JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
  [ -n "$HOME" ] && HOME=`cygpath --path --windows "$HOME"`
  [ -n "$BASEDIR" ] && BASEDIR=`cygpath --path --windows "$BASEDIR"`
  [ -n "$REPO" ] && REPO=`cygpath --path --windows "$REPO"`
fi

exec "$JAVACMD" $JAVA_OPTS -Dlavoisier.configuration=lavoisier-config.xml \
  -classpath "$CLASSPATH" \
  -Dapp.name="lavoisier-process-config" \
  -Dapp.pid="$$" \
  -Dapp.repo="$REPO" \
  -Dapp.home="$BASEDIR" \
  -Dbasedir="$BASEDIR" \
  fr.in2p3.lavoisier.command.ProcessConfig \
  "$@"
