@REM ----------------------------------------------------------------------------
@REM  Copyright 2001-2006 The Apache Software Foundation.
@REM
@REM  Licensed under the Apache License, Version 2.0 (the "License");
@REM  you may not use this file except in compliance with the License.
@REM  You may obtain a copy of the License at
@REM
@REM       http://www.apache.org/licenses/LICENSE-2.0
@REM
@REM  Unless required by applicable law or agreed to in writing, software
@REM  distributed under the License is distributed on an "AS IS" BASIS,
@REM  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@REM  See the License for the specific language governing permissions and
@REM  limitations under the License.
@REM ----------------------------------------------------------------------------
@REM
@REM   Copyright (c) 2001-2006 The Apache Software Foundation.  All rights
@REM   reserved.

@echo off

set ERROR_CODE=0

:init
@REM Decide how to startup depending on the version of windows

@REM -- Win98ME
if NOT "%OS%"=="Windows_NT" goto Win9xArg

@REM set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" @setlocal

@REM -- 4NT shell
if "%eval[2+2]" == "4" goto 4NTArgs

@REM -- Regular WinNT shell
set CMD_LINE_ARGS=%*
goto WinNTGetScriptDir

@REM The 4NT Shell from jp software
:4NTArgs
set CMD_LINE_ARGS=%$
goto WinNTGetScriptDir

:Win9xArg
@REM Slurp the command line arguments.  This loop allows for an unlimited number
@REM of arguments (up to the command line limit, anyway).
set CMD_LINE_ARGS=
:Win9xApp
if %1a==a goto Win9xGetScriptDir
set CMD_LINE_ARGS=%CMD_LINE_ARGS% %1
shift
goto Win9xApp

:Win9xGetScriptDir
set SAVEDIR=%CD%
%0\
cd %0\..\.. 
set BASEDIR=%CD%
cd %SAVEDIR%
set SAVE_DIR=
goto repoSetup

:WinNTGetScriptDir
set BASEDIR=%~dp0\..

:repoSetup


if "%JAVACMD%"=="" set JAVACMD=java

if "%REPO%"=="" set REPO=%BASEDIR%\lib

set CLASSPATH="%BASEDIR%"\etc;"%REPO%"\lavoisier-service-1.9.jar;"%REPO%"\lavoisier-engine-1.9.jar;"%REPO%"\lavoisier-configuration-1.9.jar;"%REPO%"\lavoisier-interfaces-1.9.jar;"%REPO%"\xpath-parser-1.9.jar;"%REPO%"\jaxen-1.1.4.jar;"%REPO%"\dom4j-1.6.1.jar;"%REPO%"\xml-apis-1.0.b2.jar;"%REPO%"\lavoisier-chaining-1.9.jar;"%REPO%"\straxpath-1.9.jar;"%REPO%"\log4j-1.2.12.jar;"%REPO%"\grizzly-http-server-2.2.21.jar;"%REPO%"\grizzly-http-2.2.21.jar;"%REPO%"\grizzly-framework-2.2.21.jar;"%REPO%"\grizzly-rcm-2.2.21.jar;"%REPO%"\lavoisier-cache-base-1.9.jar;"%REPO%"\lavoisier-connector-base-1.9.jar;"%REPO%"\lavoisier-connector-diff-1.9.jar;"%REPO%"\xmlunit-1.3.jar;"%REPO%"\lavoisier-connector-sql-1.9.jar;"%REPO%"\mysql-connector-java-5.1.25.jar;"%REPO%"\postgresql-9.2-1003-jdbc4.jar;"%REPO%"\hsqldb-2.2.9.jar;"%REPO%"\lavoisier-connector-ssh-1.9.jar;"%REPO%"\jsch-0.1.49.jar;"%REPO%"\lavoisier-processor-base-1.9.jar;"%REPO%"\lavoisier-processor-xpath-1.9.jar;"%REPO%"\lavoisier-renderer-base-1.9.jar;"%REPO%"\lavoisier-renderer-pdf-1.9.jar;"%REPO%"\itextpdf-5.1.3.jar;"%REPO%"\xmlworker-1.1.1.jar;"%REPO%"\lavoisier-serializer-base-1.9.jar;"%REPO%"\lavoisier-serializer-html-1.9.jar;"%REPO%"\jtidy-r938.jar;"%REPO%"\lavoisier-serializer-json-1.9.jar;"%REPO%"\jettison-1.0.1.jar;"%REPO%"\stax-api-1.0.1.jar;"%REPO%"\lavoisier-trigger-base-1.9.jar;"%REPO%"\wrapper-3.2.3.jar;"%REPO%"\lavoisier-package-1.9.jar
goto endInit

@REM Reaching here means variables are defined and arguments have been captured
:endInit

%JAVACMD% %JAVA_OPTS% -Dlavoisier.configuration=lavoisier-config.xml -classpath %CLASSPATH_PREFIX%;%CLASSPATH% -Dapp.name="lavoisier-start-console" -Dapp.repo="%REPO%" -Dapp.home="%BASEDIR%" -Dbasedir="%BASEDIR%" fr.in2p3.lavoisier.command.StartServer %CMD_LINE_ARGS%
if ERRORLEVEL 1 goto error
goto end

:error
if "%OS%"=="Windows_NT" @endlocal
set ERROR_CODE=%ERRORLEVEL%

:end
@REM set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" goto endNT

@REM For old DOS remove the set variables from ENV - we assume they were not set
@REM before we started - at least we don't leave any baggage around
set CMD_LINE_ARGS=
goto postExec

:endNT
@REM If error code is set to 1 then the endlocal was done already in :error.
if %ERROR_CODE% EQU 0 @endlocal


:postExec

if "%FORCE_EXIT_ON_ERROR%" == "on" (
  if %ERROR_CODE% NEQ 0 exit %ERROR_CODE%
)

exit /B %ERROR_CODE%
