<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml" indent="yes"/>

    <xsl:template match="/XPath">
        <!-- check -->
        <xsl:for-each select="descendant::AbsoluteLocationPath">
            <xsl:message terminate="yes">Absolute path not supported in this context: <xsl:apply-templates select="."/></xsl:message>
        </xsl:for-each>
        <xsl:for-each select="descendant::Function[@s1='position' or @s1='last']">
            <xsl:message terminate="yes">Function not supported in this context: <xsl:apply-templates select="@s1"/>()</xsl:message>
        </xsl:for-each>
        <xsl:for-each select="descendant::NameStep[
                                    starts-with(@axis,'preceding') or
                                    starts-with(@axis,'following') or
                                    ( ( starts-with(@axis,'ancestor') or @axis='parent' )
                                      and
                                      ( following-sibling::NameStep/@axis='child' or following-sibling::TextNodeStep or following-sibling::CommentNodeStep )
                                    )
                                  ]"
                >
            <xsl:message terminate="yes">Axis not supported in this context: <xsl:value-of select="@axis"/></xsl:message>
        </xsl:for-each>

        <!-- create element -->
        <straxpath>
            <xsl:attribute name="relative">
                <xsl:apply-templates select="*"/>
            </xsl:attribute>
        </straxpath>
    </xsl:template>

    <xsl:include href="xpath-serializer.xsl"/>
</xsl:stylesheet>
