<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:cfg="http://software.in2p3.fr/lavoisier/config.xsd">
    <xsl:output method="xml" omit-xml-declaration="yes"/>

    <xsl:template match="cfg:parameter/@isXML"/>

    <xsl:template match="@eval[contains(.,'path(-1)')]">
        <xsl:call-template name="EVAL"><xsl:with-param name="item"/></xsl:call-template>
    </xsl:template>
    <xsl:template match="@eval[contains(.,'path(5)')]">
        <xsl:call-template name="EVAL"><xsl:with-param name="item">5</xsl:with-param></xsl:call-template>
    </xsl:template>
    <xsl:template match="@eval[contains(.,'path(4)')]">
        <xsl:call-template name="EVAL"><xsl:with-param name="item">4</xsl:with-param></xsl:call-template>
    </xsl:template>
    <xsl:template match="@eval[contains(.,'path(3)')]">
        <xsl:call-template name="EVAL"><xsl:with-param name="item">3</xsl:with-param></xsl:call-template>
    </xsl:template>
    <xsl:template match="@eval[contains(.,'path(2)')]">
        <xsl:call-template name="EVAL"><xsl:with-param name="item">2</xsl:with-param></xsl:call-template>
    </xsl:template>
    <xsl:template match="@eval[contains(.,'path(1)')]">
        <xsl:call-template name="EVAL"><xsl:with-param name="item">1</xsl:with-param></xsl:call-template>
    </xsl:template>
    <xsl:template name="EVAL">
        <xsl:param name="item"/>
        <xsl:attribute name="eval">
            <xsl:value-of select="substring-before(., concat('path(',$item,')'))"/>
            <xsl:text/>path('<xsl:value-of select="$item"/>')<xsl:text/>
            <xsl:value-of select="substring-after(., concat('path(',$item,')'))"/>
        </xsl:attribute>
    </xsl:template>

    <xsl:template match="cfg:view[contains(descendant::cfg:*/@eval, 'path(5)')]" priority="5">
        <xsl:copy>
            <xsl:attribute name="path_template">/{1}/{2}/{3}/{4}/{5}</xsl:attribute>
            <xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
    <xsl:template match="cfg:view[contains(descendant::cfg:*/@eval, 'path(4)')]" priority="4">
        <xsl:copy>
            <xsl:attribute name="path-template">/{1}/{2}/{3}/{4}</xsl:attribute>
            <xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
    <xsl:template match="cfg:view[contains(descendant::cfg:*/@eval, 'path(3)')]" priority="3">
        <xsl:copy>
            <xsl:attribute name="path-template">/{1}/{2}/{3}</xsl:attribute>
            <xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
    <xsl:template match="cfg:view[contains(descendant::cfg:*/@eval, 'path(2)')]" priority="2">
        <xsl:copy>
            <xsl:attribute name="path-template">/{1}/{2}</xsl:attribute>
            <xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
    <xsl:template match="cfg:view[contains(descendant::cfg:*/@eval, 'path(1)')]" priority="1">
        <xsl:copy>
            <xsl:attribute name="path-template">/{1}</xsl:attribute>
            <xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>

    <!-- common -->
    <xsl:template match="/cfg:config/@version">
        <xsl:attribute name="version">
            <xsl:value-of select="number(.) + 1"/>
        </xsl:attribute>
    </xsl:template>
    <xsl:template match="@* | comment()" priority="-1">
        <xsl:copy-of select="."/>
    </xsl:template>
    <xsl:template match="*" priority="-1">
        <xsl:copy><xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>