<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4" xmlns:xalan="http://xml.apache.org/xslt"/>
    <xsl:strip-space elements="*"/>

    <xsl:template match="NameStep">
        <xsl:if test="not(following-sibling::NameStep[1][@prefix=current()/@prefix])">
            <xsl:copy><xsl:copy-of select="@*"/>
                <!-- check/add missing prefixes -->
                <xsl:if test="not(@prefix)">
                    <xsl:choose>
                        <xsl:when test="not(preceding-sibling::NameStep) and ancestor::NameStep[1]/@prefix">
                            <xsl:copy-of select="ancestor::NameStep[1]/@prefix"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:message terminate="yes">Missing required table name on element: <xsl:value-of select="@localName"/></xsl:message>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:if>
                <!-- group NameSteps with same prefix -->
                <xsl:apply-templates select="self::NameStep" mode="GROUP"/>
            </xsl:copy>
        </xsl:if>
    </xsl:template>

    <xsl:template match="NameStep" mode="GROUP">
        <xsl:choose>
            <xsl:when test="preceding-sibling::NameStep[1][@prefix=current()/@prefix]">
                <xsl:apply-templates select="preceding-sibling::NameStep[1][@prefix=current()/@prefix]" mode="GROUP"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:attribute name="linkWithPreceding">
                    <xsl:value-of select="@localName"/>
                </xsl:attribute>
            </xsl:otherwise>
        </xsl:choose>
        <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="*">
        <xsl:copy><xsl:copy-of select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>