<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4" xmlns:xalan="http://xml.apache.org/xslt"/>
    <xsl:strip-space elements="*"/>

    <xsl:template match="/AbsoluteLocationPath">
        <xsl:apply-templates select="NameStep[last()]"/>
    </xsl:template>
    <xsl:template match="/AbsoluteLocationPath/NameStep">
        <query select="{@localName}" from="{@prefix}">
            <xsl:choose>
                <xsl:when test="count(* | preceding-sibling::NameStep[1]) > 1">
                    <BooleanExpr symbol="AND">
                        <xsl:apply-templates select="*"/>
                        <xsl:if test="preceding-sibling::NameStep[1]">
                            <in column="{@pivot}">
                                <xsl:apply-templates select="preceding-sibling::NameStep[1]"/>
                            </in>
                        </xsl:if>
                    </BooleanExpr>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates select="*"/>
                    <xsl:if test="preceding-sibling::NameStep[1]">
                        <in column="{@pivot}">
                            <xsl:apply-templates select="preceding-sibling::NameStep[1]"/>
                        </in>
                    </xsl:if>
                </xsl:otherwise>
            </xsl:choose>
        </query>
    </xsl:template>

    <xsl:template match="RelativeLocationPath">
        <xsl:apply-templates select="NameStep[1]"/>
    </xsl:template>
    <xsl:template match="RelativeLocationPath/NameStep">
        <xsl:choose>
            <!-- first NameStep -->
            <xsl:when test="not(preceding-sibling::NameStep)">
                <xsl:choose>
                    <!-- same table -->
                    <xsl:when test="@prefix=ancestor::NameStep[1]/@prefix">
                        <xsl:apply-templates select="self::NameStep" mode="COMMON"/>
                    </xsl:when>
                    <!-- other table -->
                    <xsl:otherwise>
                        <in column="{ancestor::NameStep[1]/@pivot}">
                            <query select="{@pivot}" from="{@prefix}">
                                <xsl:apply-templates select="self::NameStep" mode="COMMON"/>
                            </query>
                        </in>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <!-- other NameStep -->
            <xsl:otherwise>
                <in column="{preceding-sibling::NameStep[1]/@localName}">
                    <query select="{@pivot}" from="{@prefix}">
                        <xsl:apply-templates select="self::NameStep" mode="COMMON"/>
                    </query>
                </in>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="RelativeLocationPath/NameStep" mode="COMMON">
        <xsl:choose>
            <xsl:when test="not(following-sibling::NameStep)">
                <Comparison symbol="{ancestor::Comparison/@symbol}">
                    <Column>
                        <xsl:value-of select="@localName"/>
                    </Column>
                    <xsl:copy-of select="ancestor::Comparison/Literal | ancestor::Comparison/Number"/>
                </Comparison>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="following-sibling::NameStep[1]"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="AndExpr">
        <BooleanExpr symbol="AND">
            <xsl:apply-templates select="*"/>
        </BooleanExpr>
    </xsl:template>
    <xsl:template match="OrExpr">
        <BooleanExpr symbol="OR">
            <xsl:apply-templates select="*"/>
        </BooleanExpr>
    </xsl:template>
    <xsl:template match="NotExpr">
        <NotExpr>
            <xsl:apply-templates select="*"/>
        </NotExpr>
    </xsl:template>

    <xsl:template match="*">
        <xsl:apply-templates select="*"/>
    </xsl:template>
</xsl:stylesheet>