<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>

    <xsl:variable name="CR"><xsl:text>
</xsl:text></xsl:variable>
    <xsl:variable name="INDENT"><xsl:text>    </xsl:text></xsl:variable>

    <xsl:template match="/">
        <html>
            <xsl:copy-of select="document('/lavoisier/head')"/>
            <body data-spy="scroll" data-target=".subnav" data-offset="50">
                <xsl:copy-of select="document('/lavoisier/navbar')"/>
                <div class="container fluid" style="margin-top:80px">
                    <xsl:apply-templates/>
                </div>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="group">
        <ul>
            <xsl:for-each select="*">
                <li>
                    <xsl:apply-templates select="."/>
                </li>
            </xsl:for-each>
        </ul>
    </xsl:template>

    <xsl:template match="mbean">
        <pre>
            <xsl:text/>&lt;!-- <i><xsl:value-of select="@description"/></i> --&gt;<xsl:text/>
            <xsl:value-of select="$CR"/>
            <xsl:text/>&lt;<b><xsl:apply-templates select="@className"/></b> type="<i><xsl:apply-templates select="@name"/></i>"&gt;<xsl:text/>
                <xsl:apply-templates/>
            <xsl:value-of select="$CR"/>
            <xsl:text/>&lt;/<b><xsl:apply-templates select="@className"/></b>&gt;<xsl:text/>
        </pre>
    </xsl:template>
    <xsl:template match="mbean/@className">
        <a href="/lavoisier/adaptor/jmx/domain/group/mbean[@className='{.}']">
            <xsl:choose>
                <xsl:when test="contains(.,'SimpleCache')">cache</xsl:when>
                <xsl:when test="contains(.,'Connector')">connector</xsl:when>
                <xsl:when test="contains(.,'Serializer')">serializer</xsl:when>
                <xsl:when test="contains(.,'Processor')">processor</xsl:when>
                <xsl:when test="contains(.,'Renderer')">renderer</xsl:when>
                <xsl:when test="contains(.,'Trigger')">trigger</xsl:when>
                <xsl:otherwise>
                    <xsl:message terminate="yes">Unexpected interface: <xsl:value-of select="."/></xsl:message>
                </xsl:otherwise>
            </xsl:choose>
        </a>
    </xsl:template>
    <xsl:template match="mbean/@name">
        <a href="/lavoisier/adaptor/jmx/domain/group/mbean[@name='{.}']">
            <xsl:value-of select="."/>
        </a>
    </xsl:template>

    <xsl:template match="attribute">
        <xsl:value-of select="$CR"/><xsl:value-of select="$INDENT"/>
        <xsl:value-of select="$CR"/><xsl:value-of select="$INDENT"/>
        <xsl:text/>&lt;!-- <i><xsl:apply-templates select="value/@optional"/>: <xsl:value-of
            select="@description"/> (<xsl:value-of select="value/@type"/>)</i> --&gt;<xsl:text/>
        <xsl:value-of select="$CR"/><xsl:value-of select="$INDENT"/>
        <xsl:text/>&lt;<b>parameter</b> name="<i><xsl:value-of select="@name"/></i>"<xsl:text/>
        <xsl:choose>
            <xsl:when test="value/@default!=''">
                <xsl:text/>&gt;<xsl:apply-templates/>&lt;/<b>parameter</b>&gt;<xsl:text/>
            </xsl:when>
            <xsl:otherwise>/&gt;</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="value/@optional[.='true']">optional</xsl:template>
    <xsl:template match="value/@optional[.='false']">required</xsl:template>

    <xsl:template match="value">
        <xsl:value-of select="@default"/>
    </xsl:template>

    <xsl:template match="*[namespace-uri()='http://software.in2p3.fr/lavoisier/entries.xsd' and local-name()='entries']">
        <xsl:choose>
            <xsl:when test="count(*) > 1">
                <ul>
                    <xsl:for-each select="*">
                        <li>
                            <xsl:apply-templates select="."/>
                        </li>
                    </xsl:for-each>
                </ul>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="*[namespace-uri()='http://software.in2p3.fr/lavoisier/entries.xsd' and local-name()='entry']">
        <xsl:value-of select="text()"/>
    </xsl:template>

    <xsl:template match="*">
        <xsl:apply-templates/>
    </xsl:template>
</xsl:stylesheet>