<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:cfg="http://software.in2p3.fr/lavoisier/config.xsd">
    <xsl:output method="html" encoding="utf-8" indent="yes" />

    <xsl:template match="/">
        <html>
            <xsl:copy-of select="document('/lavoisier/head')"/>
            <body data-spy="scroll" data-target=".subnav" data-offset="50">
                <xsl:copy-of select="document('/lavoisier/navbar')"/>
                <div class="container fluid" style="margin-top:80px">
                    <xsl:apply-templates/>
                </div>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="cfg:config">
        <table class="table table-bordered table-striped table-sorted table-hover">
            <tr>
                <td>
                    <a href="/lavoisier/category/cfg:config/cfg:view[cfg:info/cfg:category/text()='Monitoring']">Monitoring</a>
                </td>
                <td>
                    <xsl:for-each select="cfg:view[cfg:info/cfg:category/text()='Monitoring']">
                        <xsl:apply-templates select="."/>
                    </xsl:for-each>
                </td>
            </tr>
            <tr>
                <td>
                    <a href="/lavoisier/category/cfg:config/cfg:view[cfg:info/cfg:category/text()='Configuration']">Configuration</a>
                </td>
                <td>
                    <xsl:for-each select="cfg:view[cfg:info/cfg:category/text()='Configuration']">
                        <xsl:apply-templates select="."/>
                    </xsl:for-each>
                </td>
            </tr>
            <tr>
                <td>
                    <a href="/lavoisier/category/cfg:config/cfg:view[cfg:info/cfg:category/text()='Environment']">Environment</a>
                </td>
                <td>
                    <xsl:for-each select="cfg:view[cfg:info/cfg:category/text()='Environment']">
                        <xsl:apply-templates select="."/>
                    </xsl:for-each>
                </td>
            </tr>
            <tr>
                <td>
                    <a href="/lavoisier/category/cfg:config/cfg:view[cfg:info/cfg:category/text()='Documentation']">Documentation</a>
                </td>
                <td>
                    <xsl:for-each select="cfg:view[cfg:info/cfg:category/text()='Documentation']">
                        <xsl:apply-templates select="."/>
                    </xsl:for-each>
                </td>
            </tr>
            <tr>
                <td>
                    <a href="/lavoisier/category/cfg:config/cfg:view[not(cfg:info/cfg:category/text()
or cfg:info/cfg:category/text()='Monitoring'
or cfg:info/cfg:category/text()='Configuration'
or cfg:info/cfg:category/text()='Environment'
or cfg:info/cfg:category/text()='Documentation'
or cfg:info/cfg:category/text()='Hidden')]">User</a>
                </td>
                <td>
                    <xsl:for-each select="cfg:view[not(cfg:info/cfg:category/text()
or cfg:info/cfg:category/text()='Monitoring'
or cfg:info/cfg:category/text()='Configuration'
or cfg:info/cfg:category/text()='Environment'
or cfg:info/cfg:category/text()='Documentation'
or cfg:info/cfg:category/text()='Hidden')]">
                        <xsl:apply-templates select="."/>
                    </xsl:for-each>
                </td>
            </tr>
        </table>
    </xsl:template>

    <xsl:template match="cfg:view">
        <a class="btn span2" href="/lavoisier/{@name}{cfg:info/cfg:path/text()}" title="{cfg:info/cfg:description/text()}">
            <xsl:value-of select="@name"/>
        </a>
    </xsl:template>

    <xsl:template match="*[namespace-uri()='http://software.in2p3.fr/lavoisier/entries.xsd' and local-name()='entries']">
        <xsl:choose>
            <xsl:when test="count(*) > 1">
                <ul>
                    <xsl:for-each select="*">
                        <li>
                            <xsl:apply-templates select="."/>
                        </li>
                    </xsl:for-each>
                </ul>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="*[namespace-uri()='http://software.in2p3.fr/lavoisier/entries.xsd' and local-name()='entry']">
        <xsl:value-of select="text()"/>
    </xsl:template>

    <xsl:template match="*">
        <xsl:apply-templates/>
    </xsl:template>
</xsl:stylesheet>